unit uCountThread;

interface

uses
  Classes;

type

  TOnMsg = procedure(AMsg: string) of object;
  // delphi  string ǰ const,Ч
  // ﲻӣԭǲ̫ʵѾƿˣʱ)

  TCountThread = class; // ǰ
  TCountAction = (caNeedANum, caCountResult, caStop);
  TOnCountAction = procedure(Sender: TCountThread; ACountAction: TCountAction) of object;

  TCountThread = Class(TThread)
  private
    FOnCountAction: TOnCountAction;
    FOnMsg: TOnMsg;

    procedure DoOnCountAction(ACountAction: TCountAction);
    procedure DoOnMsg(AMsg: string);

    procedure SetOnCountAction(val: TOnCountAction);
    procedure SetOnMsg(val: TOnMsg);
  private
    procedure Count;
  protected
    procedure Execute; override;
  public
    property OnCountAction: TOnCountAction read FOnCountAction write SetOnCountAction;
    property OnMsg: TOnMsg read FOnMsg write SetOnMsg;
  public
    constructor Create; reintroduce;
  public
    Num: integer;
    Sum: integer;
    AllowedCount: boolean;
    Row: integer; // 浱ǰ Num к
  End;

implementation

uses
  SysUtils;

procedure TCountThread.Count;
var
  i: integer;
begin
  Sum := 0;
  for i := 1 to Num do
  begin
    Sum := Sum + i;
    sleep(1); // ̫˿Ч
    //ʵʹУҪ sleep,ΪʾҪ
  end;
end;

constructor TCountThread.Create;
begin
  inherited Create(false); // ִ Execute еĴ롣
  FreeOnTerminate := false; // ˳ Execute еĴ벻ͷԴɵֶͷ(free)
  Num := 0;
  Sum := 0;
  AllowedCount := false; //߳ɶҲܣҪݴ
end;

procedure TCountThread.DoOnCountAction(ACountAction: TCountAction);
begin
  if Assigned(FOnCountAction) then
    FOnCountAction(self, ACountAction);
end;

procedure TCountThread.DoOnMsg(AMsg: string);
begin
  if Assigned(FOnMsg) then
    FOnMsg(AMsg);
end;

procedure TCountThread.Execute;
begin
  inherited;
  while not Terminated do // ѭ
  begin

    if AllowedCount then // 
    //ѭ߳вͣؼָʾļд.
    //ʵ̴߳룬 TEvent 棬Ҫ.
    //ʵ߳ʵ(:TSimpleThread)ԴУԴ룬ҿʹá

    begin

      Num := 0;
      DoOnCountAction(caNeedANum); // һ Num
      if Num > 0 then
      begin
        DoOnMsg('N:' + IntToStr(Num));
        Count; // 
        DoOnMsg('NۼӺΪ:' + IntToStr(Sum));
        DoOnCountAction(caCountResult); // ߷ؼ
      end;

    end;

    sleep(10);

  end;
  DoOnMsg('߳Ͻ');
  DoOnCountAction(caStop); // ֪ߣ߳Ͻ
end;

procedure TCountThread.SetOnCountAction(val: TOnCountAction);
begin
  FOnCountAction := val;
end;

procedure TCountThread.SetOnMsg(val: TOnMsg);
begin
  FOnMsg := val;
end;

end.
